package com.jiuqi.util;

package .tmp;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;

public class BitMatrix {
  private List bits = new ArrayList();
  
  public void clear() {
    for (int i = 0; i < this.bits.size(); i++)
      this.bits.set(i, null); 
  }
  
  public boolean get(int x, int y) {
    BitSet bs = (y < this.bits.size()) ? this.bits.get(y) : null;
    return (bs == null || x >= bs.size()) ? false : bs.get(x);
  }
  
  public void set(int x, int y, boolean value) {
    for (; this.bits.size() <= y; this.bits.add(null));
    BitSet bs = this.bits.get(y);
    if (bs == null) {
      if (!value)
        return; 
      bs = new BitSet();
      this.bits.set(y, bs);
    } 
    if (value) {
      bs.set(x);
    } else {
      bs.clear(x);
    } 
  }
  
  public boolean hasTrue(int y) {
    if (y >= this.bits.size())
      return false; 
    BitSet bs = this.bits.get(y);
    if (bs == null)
      return false; 
    Method nextSetBit = null;
    try {
      Class[] parameterTypes = new Class[1];
      parameterTypes[0] = int.class;
      nextSetBit = bs.getClass().getMethod("nextSetBit", parameterTypes);
      if (nextSetBit != null) {
        Object[] parameters = new Object[1];
        parameters[0] = new Integer(0);
        return (((Integer)nextSetBit.invoke(bs, parameters)).intValue() >= 0);
      } 
    } catch (Exception ex) {
      ex.printStackTrace();
    } 
    for (int i = 0; i < bs.size(); i++) {
      if (bs.get(i))
        return false; 
    } 
    return true;
  }
  
  public static void main(String[] args) {
    com.jiuqi.util.BitMatrix bm = new com.jiuqi.util.BitMatrix();
    bm.set(100, 1, true);
    System.out.println(bm.hasTrue(0));
    System.out.println(bm.hasTrue(1));
  }
}
